# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

BEDPOSTX_DATACHECK_METADATA = Metadata(
    id="eddcb6414c1d17da35164536bb565b595ac54640.boutiques",
    name="bedpostx_datacheck",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


BedpostxDatacheckParameters = typing.TypedDict('BedpostxDatacheckParameters', {
    "__STYX_TYPE__": typing.Literal["bedpostx_datacheck"],
    "data_dir": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "bedpostx_datacheck": bedpostx_datacheck_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


class BedpostxDatacheckOutputs(typing.NamedTuple):
    """
    Output object returned when calling `bedpostx_datacheck(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def bedpostx_datacheck_params(
    data_dir: str,
) -> BedpostxDatacheckParameters:
    """
    Build parameters.
    
    Args:
        data_dir: Data directory to check for BEDPOSTX compatibility.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "bedpostx_datacheck",
        "data_dir": data_dir,
    }
    return params


def bedpostx_datacheck_cargs(
    params: BedpostxDatacheckParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("bedpostx_datacheck")
    cargs.append(params.get("data_dir"))
    return cargs


def bedpostx_datacheck_outputs(
    params: BedpostxDatacheckParameters,
    execution: Execution,
) -> BedpostxDatacheckOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = BedpostxDatacheckOutputs(
        root=execution.output_file("."),
    )
    return ret


def bedpostx_datacheck_execute(
    params: BedpostxDatacheckParameters,
    execution: Execution,
) -> BedpostxDatacheckOutputs:
    """
    Check the data directory for BEDPOSTX compatibility.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `BedpostxDatacheckOutputs`).
    """
    params = execution.params(params)
    cargs = bedpostx_datacheck_cargs(params, execution)
    ret = bedpostx_datacheck_outputs(params, execution)
    execution.run(cargs)
    return ret


def bedpostx_datacheck(
    data_dir: str,
    runner: Runner | None = None,
) -> BedpostxDatacheckOutputs:
    """
    Check the data directory for BEDPOSTX compatibility.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        data_dir: Data directory to check for BEDPOSTX compatibility.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `BedpostxDatacheckOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(BEDPOSTX_DATACHECK_METADATA)
    params = bedpostx_datacheck_params(
        data_dir=data_dir,
    )
    return bedpostx_datacheck_execute(params, execution)


__all__ = [
    "BEDPOSTX_DATACHECK_METADATA",
    "BedpostxDatacheckOutputs",
    "BedpostxDatacheckParameters",
    "bedpostx_datacheck",
    "bedpostx_datacheck_params",
]
