# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

FABBER_ASL_METADATA = Metadata(
    id="8f7f406aa484e4ff583ff425780509d096a0a5f7.boutiques",
    name="fabber_asl",
    package="fsl",
    container_image_tag="brainlife/fsl:6.0.4-patched2",
)


FabberAslParameters = typing.TypedDict('FabberAslParameters', {
    "__STYX_TYPE__": typing.Literal["fabber_asl"],
    "listmethods": bool,
    "listmodels": bool,
    "listparams": bool,
    "descparams": bool,
    "listoutputs": bool,
    "evaluate": typing.NotRequired[str | None],
    "evaluate_params": typing.NotRequired[str | None],
    "evaluate_nt": typing.NotRequired[float | None],
    "simple_output": bool,
    "output": str,
    "overwrite": bool,
    "link_to_latest": bool,
    "method": str,
    "model": str,
    "loadmodels": typing.NotRequired[InputPathType | None],
    "data": InputPathType,
    "mask": typing.NotRequired[InputPathType | None],
    "suppdata": typing.NotRequired[InputPathType | None],
    "dump_param_names": bool,
    "save_model_fit": bool,
    "save_residuals": bool,
    "save_model_extras": bool,
    "save_mvn": bool,
    "save_mean": bool,
    "save_std": bool,
    "save_var": bool,
    "save_zstat": bool,
    "save_noise_mean": bool,
    "save_noise_std": bool,
    "save_free_energy": bool,
    "optfile": typing.NotRequired[str | None],
    "debug": bool,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "fabber_asl": fabber_asl_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "fabber_asl": fabber_asl_outputs,
    }.get(t)


class FabberAslOutputs(typing.NamedTuple):
    """
    Output object returned when calling `fabber_asl(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    logfile: OutputPathType
    """Log file of Fabber output"""
    modelfit: OutputPathType
    """Model fit output"""
    residuals: OutputPathType
    """Residuals output"""
    model_extras: OutputPathType
    """Model specific timeseries data"""
    mvn: OutputPathType
    """MVN distributions"""
    means: OutputPathType
    """Parameter means"""
    stds: OutputPathType
    """Parameter standard deviations"""
    variances: OutputPathType
    """Parameter variances"""
    zstats: OutputPathType
    """Parameter Zstats"""
    noise_means: OutputPathType
    """Noise means"""
    noise_stds: OutputPathType
    """Noise standard deviations"""
    free_energy: OutputPathType
    """Free energy"""


def fabber_asl_params(
    output: str,
    method: str,
    model: str,
    data: InputPathType,
    listmethods: bool = False,
    listmodels: bool = False,
    listparams: bool = False,
    descparams: bool = False,
    listoutputs: bool = False,
    evaluate: str | None = None,
    evaluate_params: str | None = None,
    evaluate_nt: float | None = None,
    simple_output: bool = False,
    overwrite: bool = False,
    link_to_latest: bool = False,
    loadmodels: InputPathType | None = None,
    mask: InputPathType | None = None,
    suppdata: InputPathType | None = None,
    dump_param_names: bool = False,
    save_model_fit: bool = False,
    save_residuals: bool = False,
    save_model_extras: bool = False,
    save_mvn: bool = False,
    save_mean: bool = False,
    save_std: bool = False,
    save_var: bool = False,
    save_zstat: bool = False,
    save_noise_mean: bool = False,
    save_noise_std: bool = False,
    save_free_energy: bool = False,
    optfile: str | None = None,
    debug: bool = False,
) -> FabberAslParameters:
    """
    Build parameters.
    
    Args:
        output: Directory for output files (including logfile).
        method: Use this inference method.
        model: Use this forward model.
        data: Specify a single input data file.
        listmethods: List all known inference methods.
        listmodels: List all known forward models.
        listparams: List model parameters (requires model configuration options\
            to be given).
        descparams: Describe model parameters (name, description, units) -\
            requires model configuration options to be given. Note that not all\
            models provide parameter descriptions.
        listoutputs: List additional model outputs (requires model\
            configuration options to be given).
        evaluate: Evaluate model. Set to name of output required or blank for\
            default output. Requires model configuration options, --evaluate-params\
            and --evaluate-nt.
        evaluate_params: List of parameter values for evaluation.
        evaluate_nt: Number of time points for evaluation - must be consistent\
            with model options where appropriate.
        simple_output: Instead of usual standard output, simply output series\
            of lines each giving progress as percentage.
        overwrite: If set will overwrite existing output. If not set, new\
            output directories will be created by appending '+' to the directory\
            name.
        link_to_latest: Try to create a link to the most recent output\
            directory with the prefix _latest.
        loadmodels: Load models dynamically from the specified filename, which\
            should be a DLL/shared library.
        mask: Mask file. Inference will only be performed where mask value > 0.
        suppdata: 'Supplemental' timeseries data, required for some models.
        dump_param_names: Write the file paramnames.txt containing the names of\
            the model parameters.
        save_model_fit: Output the model prediction as a 4d volume.
        save_residuals: Output the residuals (difference between the data and\
            the model prediction).
        save_model_extras: Output any additional model-specific timeseries data.
        save_mvn: Output the final MVN distributions.
        save_mean: Output the parameter means.
        save_std: Output the parameter standard deviations.
        save_var: Output the parameter variances.
        save_zstat: Output the parameter Zstats.
        save_noise_mean: Output the noise means. The noise distribution\
            inferred is the precision of a Gaussian noise source.
        save_noise_std: Output the noise standard deviations.
        save_free_energy: Output the free energy, if calculated.
        optfile: File containing additional options, one per line, in the same\
            form as specified on the command line.
        debug: Output large amounts of debug information. ONLY USE WITH VERY\
            SMALL NUMBERS OF VOXELS.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "fabber_asl",
        "listmethods": listmethods,
        "listmodels": listmodels,
        "listparams": listparams,
        "descparams": descparams,
        "listoutputs": listoutputs,
        "simple_output": simple_output,
        "output": output,
        "overwrite": overwrite,
        "link_to_latest": link_to_latest,
        "method": method,
        "model": model,
        "data": data,
        "dump_param_names": dump_param_names,
        "save_model_fit": save_model_fit,
        "save_residuals": save_residuals,
        "save_model_extras": save_model_extras,
        "save_mvn": save_mvn,
        "save_mean": save_mean,
        "save_std": save_std,
        "save_var": save_var,
        "save_zstat": save_zstat,
        "save_noise_mean": save_noise_mean,
        "save_noise_std": save_noise_std,
        "save_free_energy": save_free_energy,
        "debug": debug,
    }
    if evaluate is not None:
        params["evaluate"] = evaluate
    if evaluate_params is not None:
        params["evaluate_params"] = evaluate_params
    if evaluate_nt is not None:
        params["evaluate_nt"] = evaluate_nt
    if loadmodels is not None:
        params["loadmodels"] = loadmodels
    if mask is not None:
        params["mask"] = mask
    if suppdata is not None:
        params["suppdata"] = suppdata
    if optfile is not None:
        params["optfile"] = optfile
    return params


def fabber_asl_cargs(
    params: FabberAslParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("fabber_asl")
    if params.get("listmethods"):
        cargs.append("--listmethods")
    if params.get("listmodels"):
        cargs.append("--listmodels")
    if params.get("listparams"):
        cargs.append("--listparams")
    if params.get("descparams"):
        cargs.append("--descparams")
    if params.get("listoutputs"):
        cargs.append("--listoutputs")
    if params.get("evaluate") is not None:
        cargs.append(params.get("evaluate"))
    if params.get("evaluate_params") is not None:
        cargs.append(params.get("evaluate_params"))
    if params.get("evaluate_nt") is not None:
        cargs.append(str(params.get("evaluate_nt")))
    if params.get("simple_output"):
        cargs.append("--simple-output")
    cargs.append(params.get("output"))
    if params.get("overwrite"):
        cargs.append("--overwrite")
    if params.get("link_to_latest"):
        cargs.append("--link-to-latest")
    cargs.append(params.get("method"))
    cargs.append(params.get("model"))
    if params.get("loadmodels") is not None:
        cargs.append(execution.input_file(params.get("loadmodels")))
    cargs.append(execution.input_file(params.get("data")))
    if params.get("mask") is not None:
        cargs.append(execution.input_file(params.get("mask")))
    if params.get("suppdata") is not None:
        cargs.append(execution.input_file(params.get("suppdata")))
    if params.get("dump_param_names"):
        cargs.append("--dump-param-names")
    if params.get("save_model_fit"):
        cargs.append("--save-model-fit")
    if params.get("save_residuals"):
        cargs.append("--save-residuals")
    if params.get("save_model_extras"):
        cargs.append("--save-model-extras")
    if params.get("save_mvn"):
        cargs.append("--save-mvn")
    if params.get("save_mean"):
        cargs.append("--save-mean")
    if params.get("save_std"):
        cargs.append("--save-std")
    if params.get("save_var"):
        cargs.append("--save-var")
    if params.get("save_zstat"):
        cargs.append("--save-zstat")
    if params.get("save_noise_mean"):
        cargs.append("--save-noise-mean")
    if params.get("save_noise_std"):
        cargs.append("--save-noise-std")
    if params.get("save_free_energy"):
        cargs.append("--save-free-energy")
    if params.get("optfile") is not None:
        cargs.append(params.get("optfile"))
    if params.get("debug"):
        cargs.append("--debug")
    return cargs


def fabber_asl_outputs(
    params: FabberAslParameters,
    execution: Execution,
) -> FabberAslOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = FabberAslOutputs(
        root=execution.output_file("."),
        logfile=execution.output_file(params.get("output") + "/logfile.txt"),
        modelfit=execution.output_file(params.get("output") + "/model_fit.nii.gz"),
        residuals=execution.output_file(params.get("output") + "/residuals.nii.gz"),
        model_extras=execution.output_file(params.get("output") + "/extras.nii.gz"),
        mvn=execution.output_file(params.get("output") + "/mvn.nii.gz"),
        means=execution.output_file(params.get("output") + "/means.nii.gz"),
        stds=execution.output_file(params.get("output") + "/stds.nii.gz"),
        variances=execution.output_file(params.get("output") + "/variances.nii.gz"),
        zstats=execution.output_file(params.get("output") + "/zstats.nii.gz"),
        noise_means=execution.output_file(params.get("output") + "/noise_means.nii.gz"),
        noise_stds=execution.output_file(params.get("output") + "/noise_stds.nii.gz"),
        free_energy=execution.output_file(params.get("output") + "/free_energy.nii.gz"),
    )
    return ret


def fabber_asl_execute(
    params: FabberAslParameters,
    execution: Execution,
) -> FabberAslOutputs:
    """
    Fabber is a tool for automated model fitting of time series data.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `FabberAslOutputs`).
    """
    params = execution.params(params)
    cargs = fabber_asl_cargs(params, execution)
    ret = fabber_asl_outputs(params, execution)
    execution.run(cargs)
    return ret


def fabber_asl(
    output: str,
    method: str,
    model: str,
    data: InputPathType,
    listmethods: bool = False,
    listmodels: bool = False,
    listparams: bool = False,
    descparams: bool = False,
    listoutputs: bool = False,
    evaluate: str | None = None,
    evaluate_params: str | None = None,
    evaluate_nt: float | None = None,
    simple_output: bool = False,
    overwrite: bool = False,
    link_to_latest: bool = False,
    loadmodels: InputPathType | None = None,
    mask: InputPathType | None = None,
    suppdata: InputPathType | None = None,
    dump_param_names: bool = False,
    save_model_fit: bool = False,
    save_residuals: bool = False,
    save_model_extras: bool = False,
    save_mvn: bool = False,
    save_mean: bool = False,
    save_std: bool = False,
    save_var: bool = False,
    save_zstat: bool = False,
    save_noise_mean: bool = False,
    save_noise_std: bool = False,
    save_free_energy: bool = False,
    optfile: str | None = None,
    debug: bool = False,
    runner: Runner | None = None,
) -> FabberAslOutputs:
    """
    Fabber is a tool for automated model fitting of time series data.
    
    Author: FMRIB Analysis Group, University of Oxford
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki
    
    Args:
        output: Directory for output files (including logfile).
        method: Use this inference method.
        model: Use this forward model.
        data: Specify a single input data file.
        listmethods: List all known inference methods.
        listmodels: List all known forward models.
        listparams: List model parameters (requires model configuration options\
            to be given).
        descparams: Describe model parameters (name, description, units) -\
            requires model configuration options to be given. Note that not all\
            models provide parameter descriptions.
        listoutputs: List additional model outputs (requires model\
            configuration options to be given).
        evaluate: Evaluate model. Set to name of output required or blank for\
            default output. Requires model configuration options, --evaluate-params\
            and --evaluate-nt.
        evaluate_params: List of parameter values for evaluation.
        evaluate_nt: Number of time points for evaluation - must be consistent\
            with model options where appropriate.
        simple_output: Instead of usual standard output, simply output series\
            of lines each giving progress as percentage.
        overwrite: If set will overwrite existing output. If not set, new\
            output directories will be created by appending '+' to the directory\
            name.
        link_to_latest: Try to create a link to the most recent output\
            directory with the prefix _latest.
        loadmodels: Load models dynamically from the specified filename, which\
            should be a DLL/shared library.
        mask: Mask file. Inference will only be performed where mask value > 0.
        suppdata: 'Supplemental' timeseries data, required for some models.
        dump_param_names: Write the file paramnames.txt containing the names of\
            the model parameters.
        save_model_fit: Output the model prediction as a 4d volume.
        save_residuals: Output the residuals (difference between the data and\
            the model prediction).
        save_model_extras: Output any additional model-specific timeseries data.
        save_mvn: Output the final MVN distributions.
        save_mean: Output the parameter means.
        save_std: Output the parameter standard deviations.
        save_var: Output the parameter variances.
        save_zstat: Output the parameter Zstats.
        save_noise_mean: Output the noise means. The noise distribution\
            inferred is the precision of a Gaussian noise source.
        save_noise_std: Output the noise standard deviations.
        save_free_energy: Output the free energy, if calculated.
        optfile: File containing additional options, one per line, in the same\
            form as specified on the command line.
        debug: Output large amounts of debug information. ONLY USE WITH VERY\
            SMALL NUMBERS OF VOXELS.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FabberAslOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FABBER_ASL_METADATA)
    params = fabber_asl_params(
        listmethods=listmethods,
        listmodels=listmodels,
        listparams=listparams,
        descparams=descparams,
        listoutputs=listoutputs,
        evaluate=evaluate,
        evaluate_params=evaluate_params,
        evaluate_nt=evaluate_nt,
        simple_output=simple_output,
        output=output,
        overwrite=overwrite,
        link_to_latest=link_to_latest,
        method=method,
        model=model,
        loadmodels=loadmodels,
        data=data,
        mask=mask,
        suppdata=suppdata,
        dump_param_names=dump_param_names,
        save_model_fit=save_model_fit,
        save_residuals=save_residuals,
        save_model_extras=save_model_extras,
        save_mvn=save_mvn,
        save_mean=save_mean,
        save_std=save_std,
        save_var=save_var,
        save_zstat=save_zstat,
        save_noise_mean=save_noise_mean,
        save_noise_std=save_noise_std,
        save_free_energy=save_free_energy,
        optfile=optfile,
        debug=debug,
    )
    return fabber_asl_execute(params, execution)


__all__ = [
    "FABBER_ASL_METADATA",
    "FabberAslOutputs",
    "FabberAslParameters",
    "fabber_asl",
    "fabber_asl_params",
]
